package vishnu.testvis.object;
import java.io.*;
import java.net.*;
import java.util.*;
import vishnu.datablock.*;
import vishnu.testvis.visual.*;
import vishnu.server.Packaging;
import vishnu.util.XMLUtil;
import vishnu.util.Base64;

import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.apache.xerces.parsers.DOMParser;

public class GSDLEngine extends Engine
{
    public GSDLEngine() {
    }
    
    public GSDLEngine(Vishnu display)
    {
	this.setDisplay(display);
    }
        
    public Vector getCollections(Vector q) {
	return null;
    }
    
    public DataBlock getData(String query_term, String collection, String view) {

	
	String query = servlet+"&type=search&q="+query_term;
	if (view != null) {
	    query += "&view="+view;
	}
	System.out.println("sending query: " + query_term);
	DataBlock db = null;
	try {
	    URL cgi = new URL(query);
	    DataInputStream in = new DataInputStream(cgi.openStream());
	    DOMParser parser = new DOMParser();
	    parser.parse(new InputSource(in));
	    Document data_doc = parser.getDocument();
	    Element data_elem = data_doc.getDocumentElement();
	    String results = XMLUtil.getNodeText(data_elem);
	    
	    // unserialize the data block
	    db = (DataBlock) Base64.decodeToObject(results);
	    //byte [] bytes = results.getBytes("UTF-8");
// 	    byte [] bytes = Base64.decode(results);
// 	    ByteArrayInputStream bais = new ByteArrayInputStream(bytes);
// 	    ObjectInputStream ois = new ObjectInputStream(bais);
// 	    db = (DataBlock)ois.readObject();
//	    ois.close();
// 	    Element cluster_results = (Element)XMLUtil.getChildByTagName(data_elem, "cluster");
// 	    String results = XMLUtil.getNodeText(cluster_results);
// 	    //System.out.println("recived results:" + results);
// 	    Element description_results = (Element)XMLUtil.getChildByTagName(data_elem, "descriptions");
// 	    NodeList descs = description_results.getElementsByTagName("desc");
// 	    Vector desc_vector = new Vector();
// 	    for (int i=0; i<descs.getLength(); i++) {
// 		String d = XMLUtil.getNodeText((Element)descs.item(i));
// 		desc_vector.add(d);
// 	    }
// 	    Packaging p = new Packaging();
// 	    db = p.getDataPackage(results, desc_vector);
	    in.close();
	} catch (Exception e) {
	    System.err.println( "Error sending query to cgi: " + e);
	    e.printStackTrace();
	    return null;
	}
	return db;

    }

    public Vector getDocument(String id, String collection, String view) {
	String query = servlet+"&type=fetch&d="+id;
	if (view != null) {
	    query += "&view="+view;
	}	
	System.out.println("sending fetch: " + id);
	Vector doc;
	try {
	    URL cgi = new URL(query);
	    DataInputStream in = new DataInputStream(cgi.openStream());
	    DOMParser parser = new DOMParser();
	    parser.parse(new InputSource(in));
	    Document data_doc = parser.getDocument();
	    Element data_elem = data_doc.getDocumentElement();
	    String results = XMLUtil.getNodeText(data_elem);
	    System.out.println("recived results:" + results);
	    // ugly hack. make this nicer!!
	    doc = new Vector(Arrays.asList(results.split("\n")));
	    in.close();
	} catch (Exception e) {
	    System.err.println( "Error sending query to cgi: " + e);
	    e.printStackTrace();
	    return null;
	}
	return doc;
		
    }
    
}
